Subject: Re: [PATCH 13/16] powerpc: add ps3 platform lpar addressing

From: Michael Ellerman <[email-masked]>
Date: Mon, 13 Nov 2006 11:41:54 +1100

On Sun, 2006-11-12 at 11:45 +1100, Benjamin Herrenschmidt wrote:
> On Sat, 2006-11-11 at 12:28 +0100, Christoph Hellwig wrote:
> > On Fri, Nov 10, 2006 at 12:03:32PM -0800, Geoff Levand wrote:
> > > Adds some needed bits for a config option PS3PF_USE_LPAR_ADDR that disables
> > > the ps3pf lpar address translation mechanism.  This is a currently needed
> > > workaround for limitations in the design of the spu support.
> > 
> > So make the code do the sane thing and don't put the config in the
> > kernel tree.
> 
> Well... I'd like to keep the option for a little while.
> 
> There are performances issues with sparsemem the way it's used by
> ps3pf.. the problem is that the memory map looks like you get a bunch of
> memory at 0 (the RMO, not sure exactly how much in practice) and the
> rest in a chunk all the way up the 48 bits or so max physical space.
> 
> So sparsemem ends up with an enormous mapping only populated at the very
> beginning and the very end.
> 
> Thus, I'd like Geoff to keep the option of doing the manual translation
> in the hash code for now until I finally get some HW and thus can do
> some measurements, and possibly figure out a nicer way to deal with
> that.

I haven't read the ps3 code very carefully, but at first glance it
struck me that it has a similar problem to iSeries. It might be worth
seeing if the iSeries mschunks_map gunk can help (see
include/asm-powerpc/abs_addr.h)

cheers

-- 
Michael Ellerman
OzLabs, IBM Australia Development Lab

wwweb: http://michael.ellerman.id.au
phone: +61 2 6212 1183 (tie line 70 21183)

We do not inherit the earth from our ancestors,
we borrow it from our children. - S.M.A.R.T Person